
/**********************************************************
 * the following used by Cohen-Sutherland
 * clipping (which we don't use right now)
#define LEFT_PLANE              1
#define RIGHT_PLANE             (1<<1)
#define BOTTOM_PLANE    (1<<2)
#define TOP_PLANE               (1<<3)
#define FRONT_PLANE             (1<<4)
#define BACK_PLANE              (1<<5)
#define ALL_PLANE               (LEFT_PLANE+RIGHT_PLANE+BOTTOM_PLANE+\
                                                TOP_PLANE+FRONT_PLANE+BACK_PLANE)
extern void set_clip_planes();
************************************************************/

#include "matrix.h"

#ifndef VIEW_H
#define VIEW_H

struct transformation_info
{
   point    view_ref;
   vector   right_v;
   vector   up_v;
   vector   normal_v;
   matrix   vo_matrix;
   matrix   pp_matrix;
   matrix   vp_matrix;
   matrix   T_matrix;
   double   Zmin;
   double   Zdepth;
};

typedef struct transformation_info Transformation;

#endif

extern void     init_orientation();
extern void     eval_orientation();
extern void     eval_mapping();
extern void     eval_viewport();

extern short    pipe_vector();
extern short    pipe_line();
extern short    pipe_point();

void            update_view_info(Transformation *View,
                                 double theta, double elev, double forw,
                                 double *Location);

